;; Development helpers.

;; Copyright 2007 Kevin Ryde

;; guile-lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; guile-lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(use-modules (srfi srfi-1)
	     (srfi srfi-13)
	     (srfi srfi-14)
	     (guile-lint common))

(hash-for-each (lambda (proc arity)
		 (and (positive? (second arity))
		      (not (lint-defaults proc))
		      (format #t "`~a' no defaults for optional args\n"
			      proc)))
	       lint-arity-hash)
(exit 0)



;; Local variables:
;; compile-command: "guile -L b/inst/share/guile/site devel.scm"
;; End:
