;; Checking (gtk-2.0 gdk-pixbuf).

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (guile-lint gtk-2.0 gdk-pixbuf)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-13)
  #:use-module (gtk-2.0 gdk-pixbuf)
  #:use-module (guile-lint common)
  #:use-module (guile-lint defs)
  #:use-module (guile-lint gtk-2.0 gdk)  ;; initialize Gdk types
  #:use-module (guile-lint gtk-2.0 gtk)) ;; initialize Gtk types



;; FILENAME is a .defs file, read it and return either "1.2" or "2.0"
;; according to the gtk version it's using; return #f if can't decide
;;
(define-public (lint-gtk-defs-file-version filename)
  (call-with-input-file filename
    (lambda (port)
      (let more ((form (read port)))
	(cond ((eof-object? form)
	       #f)
	      ((not (and (list>=? form 2)
			 (eq? 'import (first form))))
	       (more port))
	      ((string-contains (second form) "1.2")
	       "1.2")
	      ((string-contains (second form) "2.0")
	       "2.0")
	      (else
	       (more (read port))))))))

(let ((filename (string-append
		 (dirname (dirname (dirname (%search-load-path
					     "gtk-2.0/gdk-pixbuf.scm"))))
		 "/guile-gtk/gdk-pixbuf.defs")))

  (if (equal? "2.0" (lint-gtk-defs-file-version filename))
      (defs-file-process (resolve-interface '(gtk-2.0 gdk-pixbuf)) filename)))
