;; Checking (ice-9 pretty-print).

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (guile-lint ice-9 pretty-print)
  #:use-module (guile-lint common)
  #:use-module (ice-9 optargs)
  #:use-module (ice-9 pretty-print)
  #:use-module (srfi srfi-1))


(define* (lint-pretty-print-fake obj #:optional port
				 #:key display? per-line-prefix width)
  #f)
(set-procedure-property! lint-pretty-print-fake 'name 'pretty-print)

(define (lint-pretty-print where now expr env)
  ;; insert fake port argument if omitted
  (if (and (>= (length expr) 3)
	   (keyword? (third expr)))
      (set! expr (cons* (car expr) (cadr expr)
			(current-output-port) (cddr expr))))
  ;; go to fake func
  (set! expr (cons lint-pretty-print-fake (cdr expr)))
  (lint-call where now expr env))
      
(lint-handler! pretty-print lint-pretty-print)


