;; Checking (srfi srfi-17).

;; Copyright 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (guile-lint srfi srfi-17)
  #:use-module (guile-lint common)
  #:use-module (srfi srfi-17))


;;-----------------------------------------------------------------------------
;; various redefined as parameterized

(lint-types! car    'pure type-any type-pair)
(lint-types! cdr    'pure type-any type-pair)

(lint-types! caar   'pure type-any type-pair)
(lint-types! cdar   'pure type-any type-pair)
(lint-types! cadr   'pure type-any type-pair)
(lint-types! cddr   'pure type-any type-pair)

(lint-types! caaar  'pure type-any type-pair)
(lint-types! cdaar  'pure type-any type-pair)
(lint-types! cadar  'pure type-any type-pair)
(lint-types! cddar  'pure type-any type-pair)
(lint-types! caadr  'pure type-any type-pair)
(lint-types! cdadr  'pure type-any type-pair)
(lint-types! caddr  'pure type-any type-pair)
(lint-types! cdddr  'pure type-any type-pair)

(lint-types! caaaar 'pure type-any type-pair)
(lint-types! cdaaar 'pure type-any type-pair)
(lint-types! cadaar 'pure type-any type-pair)
(lint-types! cddaar 'pure type-any type-pair)
(lint-types! caadar 'pure type-any type-pair)
(lint-types! cdadar 'pure type-any type-pair)
(lint-types! caddar 'pure type-any type-pair)
(lint-types! cdddar 'pure type-any type-pair)
(lint-types! caaadr 'pure type-any type-pair)
(lint-types! cdaadr 'pure type-any type-pair)
(lint-types! cadadr 'pure type-any type-pair)
(lint-types! cddadr 'pure type-any type-pair)
(lint-types! caaddr 'pure type-any type-pair)
(lint-types! cdaddr 'pure type-any type-pair)
(lint-types! cadddr 'pure type-any type-pair)
(lint-types! cddddr 'pure type-any type-pair)

(lint-types! setter 'pure type-procedure type-procedure-with-setter)

(lint-types! string-ref  'pure type-character 
	     type-string type-exact-integer-nonneg)
(lint-types! vector-ref  'pure type-any
	     type-vector type-exact-integer-nonneg)
