;; Test core functions in guile 1.6.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


;; stuff only in guile 1.6


;;-----------------------------------------------------------------------------
;; integer-expt

(pk (integer-expt 10.0 2))
(integer-expt 10.0 2)        ;; bad (called for effect)
(pk (integer-expt 10.0 -2))  ;; bad


;;-----------------------------------------------------------------------------
;; make-guardian

(pk make-guardian)
(pk (make-guardian))
(pk (make-guardian #t))
(make-guardian #t)                   ;; bad (called for effect)
(pk (make-guardian #t 99))           ;; bad

(define make-guardian-test1 (make-guardian))
(pk (make-guardian-test1))
(make-guardian-test1 (cons 1 2))
(make-guardian-test1 (cons 1 2))
(make-guardian-test1 (cons 1 2) 99)  ;; bad


;;-----------------------------------------------------------------------------
;; make-weak-vector

(pk make-weak-vector)
(pk (make-weak-vector))           ;; bad
(pk (make-weak-vector 'x))        ;; bad
(pk (make-weak-vector 10))
(make-weak-vector 10)        ;; bad (called for effect)
(pk (make-weak-vector 10 #f))
(pk (make-weak-vector 10 #f 10))  ;; bad


;;-----------------------------------------------------------------------------
;; string-append

;; ok when srfi-13 not in scope
(apply string-append '("x" "y"))


;;-----------------------------------------------------------------------------
;; weak-vector

(pk weak-vector)
(pk (weak-vector))
(pk (weak-vector 1 2 3))
