;; Test module (gtk gdk).

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(use-modules (gtk gdk))

(define sample-win
  (gdk-window-new #f 20 10 '(exposure-mask) 'input-output 'toplevel))


;;-----------------------------------------------------------------------------
;; gdk-color-intern

(pk gdk-color-intern)
(pk (gdk-color-intern))                   ;; bad
(pk (gdk-color-intern "red"))
(gdk-color-intern "red")                  ;; bad (called for effect)
(pk (gdk-color-intern (gdk-color-new)))
(pk (gdk-color-intern 'foo))              ;; bad


;;-----------------------------------------------------------------------------
;; gdk-color-pixel

(pk gdk-color-pixel)
(pk (gdk-color-pixel "red"))
(gdk-color-pixel "red")                   ;; bad (called for effect)
(pk (gdk-color-pixel 123))                ;; bad


;;-----------------------------------------------------------------------------
;; gdk-color-set-pixel

(pk gdk-color-set-pixel)
(let ((c (gdk-color-new)))
  (gdk-color-set-pixel c "red")      ;; bad
  (gdk-color-set-pixel c 123))


;;-----------------------------------------------------------------------------
;; gdk-cursor-new

(pk gdk-cursor-new)
(pk (gdk-cursor-new))                ;; bad
(pk (gdk-cursor-new 'watch))
(gdk-cursor-new 'watch)              ;; bad (called for effect)
(pk (gdk-cursor-new 'watch 'xterm))  ;; bad

(pk (gdk-cursor-new 999))            ;; bad
(pk (gdk-cursor-new 'bogus-type))    ;; bad

(gdk-window-set-cursor sample-win (gdk-cursor-new 'watch))


;;-----------------------------------------------------------------------------
;; gdk-font-intern

(pk gdk-font-intern)
(pk (gdk-font-intern))                         ;; bad
(pk (gdk-font-intern "fixed"))
(gdk-font-intern "fixed")                      ;; bad (called for effect)
(pk (gdk-font-intern (gdk-font-load "fixed")))
(pk (gdk-font-intern 'foo))                    ;; bad


;;-----------------------------------------------------------------------------
;; gdk-set-show-events

(pk gdk-set-show-events)
(gdk-set-show-events)           ;; bad
(gdk-set-show-events #f)
(gdk-set-show-events #t)
(gdk-set-show-events 'true)


;;-----------------------------------------------------------------------------
;; gdk-window-set-decorations

(pk gdk-window-set-decorations)
(gdk-window-set-decorations)                            ;; bad
(gdk-window-set-decorations sample-win)                 ;; bad
(gdk-window-set-decorations sample-win '(all))
(gdk-window-set-decorations sample-win '(all) '(all))   ;; bad

(gdk-window-set-decorations sample-win '(blah))         ;; bad
(gdk-window-set-decorations sample-win '(border blah))  ;; bad
(gdk-window-set-decorations sample-win '(border title))

