;; Test gettext in guile 1.8.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define _ gettext)


;;-----------------------------------------------------------------------------
;; error

(error (gettext "hello") 123)
(error (gettext "hello ~a") 123)                  ;; bad

(error (_ "hello") 123)
(error (_ "hello ~a") 123)                        ;; bad

(error (ngettext "hello" "world" 1) 123)
(error (ngettext "hello ~a" "world ~a" 1) 123)    ;; bad
(error (ngettext "hello" "world ~a" 1) 123)       ;; bad
(error (ngettext "hello ~a" "world" 1) 123)       ;; bad


;;-----------------------------------------------------------------------------
;; scm-error

(scm-error 'misc-error "foo" (gettext "~a") '(123) '())   
(scm-error 'misc-error "foo" (_ "~a") '(123) '())
(scm-error 'misc-error "foo" (ngettext "~a" "~a" 1) '(123) '())

(scm-error 'misc-error "foo" (gettext "~") '(123) '())          ;; bad
(scm-error 'misc-error "foo" (_ "~") '(123) '())                ;; bad
(scm-error 'misc-error "foo" (ngettext "~" "zz" 1) '(123) '())  ;; bad


;;-----------------------------------------------------------------------------
;; simple-format

(simple-format #t (gettext "") 1)             ;; bad
(simple-format #t (gettext "~a") 1)

(simple-format #t (_ "") 1)                   ;; bad
(simple-format #t (_ "~a") 1)

(simple-format #t (ngettext "" "" 1) 1)       ;; bad
(simple-format #t (ngettext "~a" "~a" 1) 1)


;;-----------------------------------------------------------------------------
;; hint simple-format

(define (hint-simple-format0 fmt . args)
  #f)
''(guile-lint simple-format hint-simple-format0)
''(guile-lint simple-format hint-simple-format0)  ;; bad
(hint-simple-format0 (gettext ""))
(hint-simple-format0 (gettext "~a"))              ;; bad
(hint-simple-format0 (_ ""))
(hint-simple-format0 (_ "~a"))                    ;; bad
(hint-simple-format0 (ngettext "" "" 1))
(hint-simple-format0 (ngettext "~a" "~a" 1))      ;; bad


;;-----------------------------------------------------------------------------
;; ice-9 format - misc

(use-modules (ice-9 format))

;; missing port arg
(format (gettext "abc ~a") 1)              	  ;; bad
(format (_ "abc ~a") 1)                    	  ;; bad
(format (ngettext "~a abc" "~a abcs" 1) 1) 	  ;; bad

;; see through gettext
(format #f (gettext "abc ~a") 1)
(format #f (gettext "blah ~a") 1 2)               ;; bad
(format #f (gettext "~Z"))                        ;; bad
(format #f (_ "abc ~a") 1)
(format #f (_ "blah ~a") 1 2)                     ;; bad
(format #f (_ "~Z"))                              ;; bad
(format #f (ngettext "abc ~a" "abcs ~a" 1) 1)
(format #f (ngettext "blah ~a" "blah ~a" 1) 1 2)  ;; bad
(format #f (ngettext "~Z" "~Z" 1))                ;; bad

