;; Test module (oop goops).

;; Copyright 2004, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(use-modules (oop goops))


;;-----------------------------------------------------------------------------
;; define-class

(pk define-class)
(define-class)                                     ;; bad
(define-class <define-class-test1>)                ;; bad

(define-class <define-class-test2> (<complex>))
(pk <define-class-test2>)

(define-class <define-class-test3> (<complex>)
  (foo #:getter define-class-test3-get-foo))
(pk define-class-test3-get-foo)
(define-class-test3-get-foo)                       ;; bad
(define-class-test3-get-foo 99)
(define-class-test3-get-foo 99 99)                 ;; bad
(pk <define-class-test3>)

(define-class <define-class-test4> (<complex>)
  (foo #:setter define-class-test4-set-foo))
(pk define-class-test4-set-foo)
(define-class-test4-set-foo)                       ;; bad
(define-class-test4-set-foo 99)                    ;; bad
(define-class-test4-set-foo 99 99)
(define-class-test4-set-foo 99 99 99)              ;; bad
(pk <define-class-test4>)

;; #:slot-ref and #:slot-set! calling
;;
(define (define-class-test5-slot-0) #f)
(define (define-class-test5-slot-1 obj) #f)
(define (define-class-test5-slot-2 obj val) #f)
(define-class <define-class-test5> (<complex>)
  (f1 #:allocation #:virtual                       ;; bad
      #:slot-ref define-class-test5-slot-0
      #:slot-set! noop)
  (f2 #:allocation #:virtual
      #:slot-ref define-class-test5-slot-1
      #:slot-set! noop)
  (f3 #:allocation #:virtual                       ;; bad
      #:slot-ref define-class-test5-slot-2
      #:slot-set! noop)
  (f4 #:allocation #:virtual                       ;; bad
      #:slot-ref noop
      #:slot-set! define-class-test5-slot-0)
  (f5 #:allocation #:virtual                       ;; bad
      #:slot-ref noop
      #:slot-set! define-class-test5-slot-1)
  (f6 #:allocation #:virtual
      #:slot-ref noop
      #:slot-set! define-class-test5-slot-2))
(pk <define-class-test5>)

;; #:init-keyword
;;
(define-class <define-class-test6> (<complex>)
  (f1 #:init-keyword #:foo)
  (f2 #:init-keyword 123))                         ;; bad
(pk <define-class-test6>)

;; #:init-thunk
;;
(define (define-class-test7-thunk-0) #f)
(define (define-class-test7-thunk-1 x) #f)
(define-class <define-class-test7> (<complex>)
  (f1 #:init-thunk define-class-test7-thunk-0)
  (f2 #:init-thunk define-class-test7-thunk-1)     ;; bad
  (f3 #:init-thunk (lambda () #f))
  (f3 #:init-thunk (lambda (x) #f)))               ;; bad
(pk <define-class-test7>)

;; #:allocation, and slot-ref and slot-set! without virtual, or vice versa
;;
(define-class <define-class-test8> (<complex>)
  (f1 #:allocation #:instance)
  (f2 #:allocation #:class)
  (f3 #:allocation #:each-subclass)
  (f4 #:allocation #:virtual)                      ;; bad
  (f5 #:allocation #:virtual #:slot-ref noop)      ;; bad
  (f6 #:allocation #:virtual #:slot-set! noop)     ;; bad
  (f7 #:allocation #:virtual #:slot-ref noop #:slot-set! noop)
  )
(pk <define-class-test8>)


;;-----------------------------------------------------------------------------
;; define-method

(pk define-method)
(define-method)                                     ;; bad

(define-method (define-method-test1))
(pk define-method-test1)

(define-method (define-method-test2 x) x)
(pk define-method-test2)

(define-method (define-method-test3 (x <complex>)) x)
(pk define-method-test3)

(define-method (define-method-test4 (x <complex>) y) x)
(pk define-method-test4)

(define-method (define-method-test5 (x <complex>) (y <real>)) x)
(pk define-method-test5)

(define-method (define-method-test6 . rest) rest)
(pk define-method-test6)

(define-method (define-method-test7 . 123) #f)      ;; bad


;;-----------------------------------------------------------------------------
;; goops-error

(pk goops-error)
(goops-error)                                       ;; bad
(goops-error "foo")
(goops-error "foo ~a" 123)
(goops-error "foo ~a")                              ;; bad


;;-----------------------------------------------------------------------------
;; make

(pk make)
(make)                                              ;; bad
(make <complex>)
(make <complex> #:blah)                             ;; bad
(make <complex> #:blah 1)
