;; Test module (ice-9 regex).

;; Copyright 2003, 2004, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

;; make-regexp is in the core
string-match     ;; bad

(use-modules (ice-9 regex))


;;-----------------------------------------------------------------------------
;; make-regexp

(pk make-regexp)
(make-regexp)                                	    ;; bad
(make-regexp ".")
(make-regexp "[")                            	    ;; bad
(make-regexp "[" regexp/icase)               	    ;; bad
(make-regexp "[" regexp/basic)               	    ;; bad
(make-regexp "[" regexp/basic regexp/icase)  	    ;; bad

(make-regexp "{6,7}" regexp/basic)
(make-regexp "{6,7}" regexp/extended)        	    ;; bad

(define make-regexp-non-constant-flag #f)
(make-regexp "{6,7}" make-regexp-non-constant-flag)
(make-regexp "[" make-regexp-non-constant-flag)     ;; bad


;;-----------------------------------------------------------------------------
;; match:end

(pk match:end)
(let ((m (string-match "(.)" "x")))
  (match:end)                          ;; bad
  (match:end m)
  (match:end m 0)
  (match:end m 1)
  (match:end m 0 999))                 ;; bad


;;-----------------------------------------------------------------------------
;; match:substring

(pk match:substring)
(let ((m (string-match "(.)" "x")))
  (match:substring)                    ;; bad
  (match:substring m)
  (match:substring m 0)
  (match:substring m 1)
  (match:substring m 0 999))           ;; bad


;;-----------------------------------------------------------------------------
;; match:start

(pk match:start)
(let ((m (string-match "(.)" "x")))
  (match:start)                        ;; bad
  (match:start m)
  (match:start m 0)
  (match:start m 1)
  (match:start m 0 999))               ;; bad


;;-----------------------------------------------------------------------------
;; regexp-substitute/global

(pk regexp-substitute/global)
(regexp-substitute/global)                      ;; bad
(regexp-substitute/global #f)                   ;; bad
(regexp-substitute/global #f ".")               ;; bad
(regexp-substitute/global #f "." "target str")  ;; bad

(regexp-substitute/global #f "." "target str" 'pre)
(regexp-substitute/global #f "." "target str" 'pre "x" 'post)

(define regexp-substitute/global-test1 "x")
(regexp-substitute/global #f "." "target str"
			  'pre regexp-substitute/global-test1 'post)

(pk (lambda ()
      (define (foo)
	(regexp-substitute/global #f "." "target str" 'pre str 'post))
      (define str "x")
      foo))

(pk (lambda ()
      (define (foo)
	(regexp-substitute/global #f "." "target str" 'pre proc 'post))  ;; bad
      (define (proc) "x")
      foo))

(pk (lambda ()
      (define (foo)
	(regexp-substitute/global #f "." "target str" 'pre proc 'post))
      (define (proc match) "x")
      foo))

(pk (lambda ()
      (define (foo)
	(regexp-substitute/global #f "." "target str" 'pre proc 'post))  ;; bad
      (define (proc match x) "x")
      foo))

(regexp-substitute/global #f "[" "target str" 'pre)  ;; bad

(regexp-substitute/global #f "." "target str" 'pre (lambda () ""))     ;; bad
(regexp-substitute/global #f "." "target str" 'pre (lambda (m) ""))
(regexp-substitute/global #f "." "target str" 'pre (lambda (m x) ""))  ;; bad


;;-----------------------------------------------------------------------------
;; string-match

(pk string-match)
(string-match)            ;; bad
(string-match ".")        ;; bad
(string-match "." "foo")
(string-match "[" "foo")  ;; bad

(string-match "." "foo" 0)
(string-match "." "foo" 0 999)   ;; bad

