;; Test module (srfi srfi-1).

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(use-modules (srfi srfi-1))


;;-----------------------------------------------------------------------------
;; apply append

(apply append '((1) (2)))    ;; bad, can use `concatenate'


;;-----------------------------------------------------------------------------
;; alist-delete

(pk alist-delete)
(pk (alist-delete))                                         ;; bad
(pk (alist-delete 'x))                                      ;; bad
(pk (alist-delete 'x (list '(x . y) '(a . b))))
(pk (alist-delete 'x (list '(x . y) '(a . b)) equal?))
(pk (alist-delete 'x (list '(x . y) '(a . b)) equal? 999))  ;; bad


;;-----------------------------------------------------------------------------
;; alist-delete!

(pk alist-delete!)
(pk (alist-delete!))                                         ;; bad
(pk (alist-delete! 'x))                                      ;; bad
(pk (alist-delete! 'x (list '(x . y) '(a . b))))
(pk (alist-delete! 'x (list '(x . y) '(a . b)) equal?))
(pk (alist-delete! 'x (list '(x . y) '(a . b)) equal? 999))  ;; bad


;;-----------------------------------------------------------------------------
;; any

(any (lambda () #f) '(123))             ;; bad
(any (lambda (x) #f) '(123))
(any (lambda (x y) #f) '(123))          ;; bad
(any (lambda (x y z) #f) '(123))        ;; bad

(any (lambda () #f) '(123) '(456))      ;; bad
(any (lambda (x) #f) '(123) '(456))     ;; bad
(any (lambda (x y) #f) '(123) '(456))
(any (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; append-map

(append-map (lambda () #f) '(123))             ;; bad
(append-map (lambda (x) #f) '(123))
(append-map (lambda (x y) #f) '(123))          ;; bad
(append-map (lambda (x y z) #f) '(123))        ;; bad

(append-map (lambda () #f) '(123) '(456))      ;; bad
(append-map (lambda (x) #f) '(123) '(456))     ;; bad
(append-map (lambda (x y) #f) '(123) '(456))
(append-map (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; append-map!

(append-map! (lambda () #f) '(123))             ;; bad
(append-map! (lambda (x) #f) '(123))
(append-map! (lambda (x y) #f) '(123))          ;; bad
(append-map! (lambda (x y z) #f) '(123))        ;; bad

(append-map! (lambda () #f) '(123) '(456))      ;; bad
(append-map! (lambda (x) #f) '(123) '(456))     ;; bad
(append-map! (lambda (x y) #f) '(123) '(456))
(append-map! (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; break

(break (lambda () #f) '(123))       ;; bad
(break (lambda (x) #f) '(123))
(break (lambda (x y) #f) '(123))    ;; bad


;;-----------------------------------------------------------------------------
;; break!

(break! (lambda () #f) '(123))      ;; bad
(break! (lambda (x) #f) '(123))
(break! (lambda (x y) #f) '(123))   ;; bad


;;-----------------------------------------------------------------------------
;; every

(every (lambda () #f) '(123))             ;; bad
(every (lambda (x) #f) '(123))
(every (lambda (x y) #f) '(123))          ;; bad
(every (lambda (x y z) #f) '(123))        ;; bad

(every (lambda () #f) '(123) '(456))      ;; bad
(every (lambda (x) #f) '(123) '(456))     ;; bad
(every (lambda (x y) #f) '(123) '(456))
(every (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; filter (core in 1.8)

(filter (lambda () #f) '(123))          ;; bad
(filter (lambda (x) #f) '(123))
(filter (lambda (x y) #f) '(123))       ;; bad

(pk filter)
(filter)                   ;; bad
(filter noop)              ;; bad
(filter noop '())
(filter noop '() '())      ;; bad
(filter noop 123)          ;; bad


;;-----------------------------------------------------------------------------
;; filter! (core in 1.8)

(filter! (lambda () #f) '(123))          ;; bad
(filter! (lambda (x) #f) '(123))
(filter! (lambda (x y) #f) '(123))       ;; bad


;;-----------------------------------------------------------------------------
;; filter-map

(filter-map (lambda () #f) '(123))             ;; bad
(filter-map (lambda (x) #f) '(123))
(filter-map (lambda (x y) #f) '(123))          ;; bad
(filter-map (lambda (x y z) #f) '(123))        ;; bad

(filter-map (lambda () #f) '(123) '(456))      ;; bad
(filter-map (lambda (x) #f) '(123) '(456))     ;; bad
(filter-map (lambda (x y) #f) '(123) '(456))
(filter-map (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; find

(find (lambda () #f) '(123))          ;; bad
(find (lambda (x) #f) '(123))
(find (lambda (x y) #f) '(123))       ;; bad


;;-----------------------------------------------------------------------------
;; find-tail

(find-tail (lambda () #f) '(123))     ;; bad
(find-tail (lambda (x) #f) '(123))
(find-tail (lambda (x y) #f) '(123))  ;; bad


;;-----------------------------------------------------------------------------
;; fold

(fold (lambda () #f) 0 '(123))                  ;; bad
(fold (lambda (x) #f) 0 '(123))                 ;; bad
(fold (lambda (x prev) #f) 0 '(123))
(fold (lambda (x y prev) #f) 0 '(123))          ;; bad
(fold (lambda (x y z prev) #f) 0 '(123))        ;; bad

(fold (lambda () #f) 0 '(123) '(456))           ;; bad
(fold (lambda (x) #f) 0 '(123) '(456))          ;; bad
(fold (lambda (x prev) #f) 0 '(123) '(456))     ;; bad
(fold (lambda (x y prev) #f) 0 '(123) '(456))
(fold (lambda (x y z prev) #f) 0 '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; fold-right

(fold-right (lambda () #f) 0 '(123))                  ;; bad
(fold-right (lambda (x) #f) 0 '(123))                 ;; bad
(fold-right (lambda (x prev) #f) 0 '(123))
(fold-right (lambda (x y prev) #f) 0 '(123))          ;; bad
(fold-right (lambda (x y z prev) #f) 0 '(123))        ;; bad

(fold-right (lambda () #f) 0 '(123) '(456))           ;; bad
(fold-right (lambda (x) #f) 0 '(123) '(456))          ;; bad
(fold-right (lambda (x prev) #f) 0 '(123) '(456))     ;; bad
(fold-right (lambda (x y prev) #f) 0 '(123) '(456))
(fold-right (lambda (x y z prev) #f) 0 '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; for-each

(for-each (lambda () #f) '(123))             ;; bad
(for-each (lambda (x) #f) '(123))
(for-each (lambda (x y) #f) '(123))          ;; bad
(for-each (lambda (x y z) #f) '(123))        ;; bad

(for-each (lambda () #f) '(123) '(456))      ;; bad
(for-each (lambda (x) #f) '(123) '(456))     ;; bad
(for-each (lambda (x y) #f) '(123) '(456))
(for-each (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; iota

(pk iota)
(pk (iota))                    ;; bad
(pk (iota 1))
(pk (iota 1 2))
(pk (iota 1 2 3))
(pk (iota 1 2 3 4))            ;; bad
(pk (iota 6 0))                ;; bad (default start 0)
(pk (iota 6 55 1))             ;; bad (default step 1)
(pk (iota 6 0 1))              ;; bad (default start 0, step 1)
(pk (iota 6 0 -1))


;;-----------------------------------------------------------------------------
;; list-index

(list-index (lambda () #f) '(123))             ;; bad
(list-index (lambda (x) #f) '(123))
(list-index (lambda (x y) #f) '(123))          ;; bad
(list-index (lambda (x y z) #f) '(123))        ;; bad

(list-index (lambda () #f) '(123) '(456))      ;; bad
(list-index (lambda (x) #f) '(123) '(456))     ;; bad
(list-index (lambda (x y) #f) '(123) '(456))
(list-index (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; lset=

(pk lset=)
(pk (lset=))                      ;; bad
(pk (lset= eqv?))                 ;; bad warn
(pk (lset= eqv? '(1 2)))          ;; bad warn
(pk (lset= eqv? '(1 2) '(2 1)))

(pk (lset= (lambda () #f) '(1 2) '(2 1)))       ;; bad
(pk (lset= (lambda (x) #f) '(1 2) '(2 1)))      ;; bad
(pk (lset= (lambda (x y) #f) '(1 2) '(2 1)))
(pk (lset= (lambda (x y z) #f) '(1 2) '(2 1)))  ;; bad


;;-----------------------------------------------------------------------------
;; lset<=

(pk lset<=)
(pk (lset<=))                      ;; bad
(pk (lset<= eqv?))                 ;; bad warn
(pk (lset<= eqv? '(1 2)))          ;; bad warn
(pk (lset<= eqv? '(1 2) '(2 1)))

(pk (lset<= (lambda () #f) '(1 2) '(2 1)))       ;; bad
(pk (lset<= (lambda (x) #f) '(1 2) '(2 1)))      ;; bad
(pk (lset<= (lambda (x y) #f) '(1 2) '(2 1)))
(pk (lset<= (lambda (x y z) #f) '(1 2) '(2 1)))  ;; bad


;;-----------------------------------------------------------------------------
;; lset-adjoin

(pk lset-adjoin)
(pk (lset-adjoin))                             ;; bad
(pk (lset-adjoin eqv?))                        ;; bad
(pk (lset-adjoin eqv? '(1 2)))                 ;; bad warn
(pk (lset-adjoin eqv? '(1 2) 3))
(pk (lset-adjoin eqv? '(1 2) 3 4))

(pk (lset-adjoin (lambda () #f) '(1 2) 3))       ;; bad
(pk (lset-adjoin (lambda (x) #f) '(1 2) 3))      ;; bad
(pk (lset-adjoin (lambda (x y) #f) '(1 2) 3))
(pk (lset-adjoin (lambda (x y z) #f) '(1 2) 3))  ;; bad


;;-----------------------------------------------------------------------------
;; lset-union

(pk lset-union)
(pk (lset-union))                      ;; bad
(pk (lset-union eqv?))                 ;; bad warn
(pk (lset-union eqv? '(1 2)))          ;; bad warn
(pk (lset-union eqv? '(1 2) '(2 1)))

(pk (lset-union (lambda () #f) '(1 2) '(2 1)))       ;; bad
(pk (lset-union (lambda (x) #f) '(1 2) '(2 1)))      ;; bad
(pk (lset-union (lambda (x y) #f) '(1 2) '(2 1)))
(pk (lset-union (lambda (x y z) #f) '(1 2) '(2 1)))  ;; bad


;;-----------------------------------------------------------------------------
;; lset-union!

(pk lset-union!)
(pk (lset-union!))                      ;; bad
(pk (lset-union! eqv?))                 ;; bad warn
(pk (lset-union! eqv? (list 1 2)))          ;; bad warn
(pk (lset-union! eqv? (list 1 2) '(2 1)))

(pk (lset-union! (lambda () #f) (list 1 2) '(2 1)))       ;; bad
(pk (lset-union! (lambda (x) #f) (list 1 2) '(2 1)))      ;; bad
(pk (lset-union! (lambda (x y) #f) (list 1 2) '(2 1)))
(pk (lset-union! (lambda (x y z) #f) (list 1 2) '(2 1)))  ;; bad


;;-----------------------------------------------------------------------------
;; lset-intersection

(pk lset-intersection)
(pk (lset-intersection))                              ;; bad
(pk (lset-intersection eqv?))                         ;; bad
(pk (lset-intersection eqv? '(1 2)))                  ;; bad warn
(pk (lset-intersection eqv? '(1 2) '(2 1)))

(pk (lset-intersection (lambda () #f) '(1 2) '(2 3)))        ;; bad
(pk (lset-intersection (lambda (x) #f) '(1 2) '(2 3)))       ;; bad
(pk (lset-intersection (lambda (x y) #f) '(1 2) '(2 3)))
(pk (lset-intersection (lambda (x y z) #f) '(1 2) '(2 3)))   ;; bad


;;-----------------------------------------------------------------------------
;; lset-intersection!

(pk lset-intersection!)
(pk (lset-intersection!))                             ;; bad
(pk (lset-intersection! eqv?))                        ;; bad
(pk (lset-intersection! eqv? (list 1 2)))             ;; bad warn
(pk (lset-intersection! eqv? (list 1 2) '(2 1)))

(pk (lset-intersection! (lambda () #f) (list 1 2) '(2 1)))       ;; bad
(pk (lset-intersection! (lambda (x) #f) (list 1 2) '(2 1)))      ;; bad
(pk (lset-intersection! (lambda (x y) #f) (list 1 2) '(2 1)))
(pk (lset-intersection! (lambda (x y z) #f) (list 1 2) '(2 1)))  ;; bad


;;-----------------------------------------------------------------------------
;; lset-difference

(pk lset-difference)
(pk (lset-difference))                              	 ;; bad
(pk (lset-difference eqv?))                         	 ;; bad
(pk (lset-difference eqv? '(1 2)))                    ;; bad warn
(pk (lset-difference eqv? '(1 2) '(2 1)))

(pk (lset-difference (lambda () #f) '(1 2) '(2 1)))        	 ;; bad
(pk (lset-difference (lambda (x) #f) '(1 2) '(2 1)))       	 ;; bad
(pk (lset-difference (lambda (x y) #f) '(1 2) '(2 1)))
(pk (lset-difference (lambda (x y z) #f) '(1 2) '(2 1)))   	 ;; bad


;;-----------------------------------------------------------------------------
;; lset-difference!

(pk lset-difference!)
(pk (lset-difference!))                             	 ;; bad
(pk (lset-difference! eqv?))                        	 ;; bad
(pk (lset-difference! eqv? (list 1 2)))               ;; bad warn
(pk (lset-difference! eqv? (list 1 2) '(2 1)))

(pk (lset-difference! (lambda () #f) (list 1 2) '(2 1)))      ;; bad
(pk (lset-difference! (lambda (x) #f) (list 1 2) '(2 1)))     ;; bad
(pk (lset-difference! (lambda (x y) #f) (list 1 2) '(2 1)))
(pk (lset-difference! (lambda (x y z) #f) (list 1 2) '(2 1))) ;; bad


;;-----------------------------------------------------------------------------
;; lset-xor

(pk lset-xor)
(pk (lset-xor))                       ;; bad
(pk (lset-xor eqv?))                  ;; bad warn
(pk (lset-xor eqv? '(1 2)))           ;; bad warn
(pk (lset-xor eqv? '(1 2) '(2 1)))

(pk (lset-xor (lambda () #f) '(1 2) '(2 1)))        ;; bad
(pk (lset-xor (lambda (x) #f) '(1 2) '(2 1)))       ;; bad
(pk (lset-xor (lambda (x y) #f) '(1 2) '(2 1)))
(pk (lset-xor (lambda (x y z) #f) '(1 2) '(2 1)))   ;; bad


;;-----------------------------------------------------------------------------
;; lset-xor!

(pk lset-xor!)
(pk (lset-xor!))                      ;; bad
(pk (lset-xor! eqv?))                 ;; bad warn
(pk (lset-xor! eqv? (list 1 2)))      ;; bad warn
(pk (lset-xor! eqv? (list 1 2) '(2 1)))

(pk (lset-xor! (lambda () #f) (list 1 2) '(2 1)))       ;; bad
(pk (lset-xor! (lambda (x) #f) (list 1 2) '(2 1)))      ;; bad
(pk (lset-xor! (lambda (x y) #f) (list 1 2) '(2 1)))
(pk (lset-xor! (lambda (x y z) #f) (list 1 2) '(2 1)))  ;; bad


;;-----------------------------------------------------------------------------
;; lset-diff+intersection

(pk lset-diff+intersection)
(pk (lset-diff+intersection))                              ;; bad
(pk (lset-diff+intersection eqv?))                         ;; bad
(pk (lset-diff+intersection eqv? '(1 2)))                  ;; bad warn
(pk (lset-diff+intersection eqv? '(1 2) '(2 1)))

(pk (lset-diff+intersection (lambda () #f) '(1 2) '(2 1)))        ;; bad
(pk (lset-diff+intersection (lambda (x) #f) '(1 2) '(2 1)))       ;; bad
(pk (lset-diff+intersection (lambda (x y) #f) '(1 2) '(2 1)))
(pk (lset-diff+intersection (lambda (x y z) #f) '(1 2) '(2 1)))   ;; bad


;;-----------------------------------------------------------------------------
;; lset-diff+intersection!

(pk lset-diff+intersection!)
(pk (lset-diff+intersection!))                             ;; bad
(pk (lset-diff+intersection! eqv?))                        ;; bad
(pk (lset-diff+intersection! eqv? (list 1 2)))                 ;; bad warn
(pk (lset-diff+intersection! eqv? (list 1 2) '(2 1)))

(pk (lset-diff+intersection! (lambda () #f) (list 1 2) '(2 3)))       ;; bad
(pk (lset-diff+intersection! (lambda (x) #f) (list 1 2) '(2 3)))      ;; bad
(pk (lset-diff+intersection! (lambda (x y) #f) (list 1 2) '(2 3)))
(pk (lset-diff+intersection! (lambda (x y z) #f) (list 1 2) '(2 3)))  ;; bad


;;-----------------------------------------------------------------------------
;; map

(map (lambda () #f) '(123))             ;; bad
(map (lambda (x) #f) '(123))
(map (lambda (x y) #f) '(123))          ;; bad
(map (lambda (x y z) #f) '(123))        ;; bad

(map (lambda () #f) '(123) '(456))      ;; bad
(map (lambda (x) #f) '(123) '(456))     ;; bad
(map (lambda (x y) #f) '(123) '(456))
(map (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; map!

(map! (lambda () #f) '(123))             ;; bad
(map! (lambda (x) #f) '(123))
(map! (lambda (x y) #f) '(123))          ;; bad
(map! (lambda (x y z) #f) '(123))        ;; bad

(map! (lambda () #f) '(123) '(456))      ;; bad
(map! (lambda (x) #f) '(123) '(456))     ;; bad
(map! (lambda (x y) #f) '(123) '(456))
(map! (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; member

(pk member)
(pk (member))                  		 ;; bad
(pk (member 1))                		 ;; bad
(pk (member 1 '(3 1 2)))
(pk (member 1 '(3 1 2) =))
(pk (member 1 '(3 1 2) = 99))                 ;; bad

(pk (member 1 '(3 1 2) (lambda () #f)))       ;; bad
(pk (member 1 '(3 1 2) (lambda (x) #f)))      ;; bad
(pk (member 1 '(3 1 2) (lambda (x y) #f)))
(pk (member 1 '(3 1 2) (lambda (x y z) #f)))  ;; bad


;;-----------------------------------------------------------------------------
;; pair-fold

(pair-fold (lambda () #f) 0 '(123))                  ;; bad
(pair-fold (lambda (x) #f) 0 '(123))                 ;; bad
(pair-fold (lambda (x prev) #f) 0 '(123))
(pair-fold (lambda (x y prev) #f) 0 '(123))          ;; bad
(pair-fold (lambda (x y z prev) #f) 0 '(123))        ;; bad

(pair-fold (lambda () #f) 0 '(123) '(456))           ;; bad
(pair-fold (lambda (x) #f) 0 '(123) '(456))          ;; bad
(pair-fold (lambda (x prev) #f) 0 '(123) '(456))     ;; bad
(pair-fold (lambda (x y prev) #f) 0 '(123) '(456))
(pair-fold (lambda (x y z prev) #f) 0 '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; pair-fold-right

(pair-fold-right (lambda () #f) 0 '(123))                  ;; bad
(pair-fold-right (lambda (x) #f) 0 '(123))                 ;; bad
(pair-fold-right (lambda (x prev) #f) 0 '(123))
(pair-fold-right (lambda (x y prev) #f) 0 '(123))          ;; bad
(pair-fold-right (lambda (x y z prev) #f) 0 '(123))        ;; bad

(pair-fold-right (lambda () #f) 0 '(123) '(456))           ;; bad
(pair-fold-right (lambda (x) #f) 0 '(123) '(456))          ;; bad
(pair-fold-right (lambda (x prev) #f) 0 '(123) '(456))     ;; bad
(pair-fold-right (lambda (x y prev) #f) 0 '(123) '(456))
(pair-fold-right (lambda (x y z prev) #f) 0 '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; pair-for-each

(pair-for-each (lambda () #f) '(123))             ;; bad
(pair-for-each (lambda (x) #f) '(123))
(pair-for-each (lambda (x y) #f) '(123))          ;; bad
(pair-for-each (lambda (x y z) #f) '(123))        ;; bad

(pair-for-each (lambda () #f) '(123) '(456))      ;; bad
(pair-for-each (lambda (x) #f) '(123) '(456))     ;; bad
(pair-for-each (lambda (x y) #f) '(123) '(456))
(pair-for-each (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; partition

(partition (lambda () #f) '(123))          ;; bad
(partition (lambda (x) #f) '(123))
(partition (lambda (x y) #f) '(123))       ;; bad


;;-----------------------------------------------------------------------------
;; partition!

(partition! (lambda () #f) '(123))          ;; bad
(partition! (lambda (x) #f) '(123))
(partition! (lambda (x y) #f) '(123))       ;; bad


;;-----------------------------------------------------------------------------
;; reduce

(pk reduce)
(reduce)                                          ;; bad
(reduce noop)                                     ;; bad
(reduce noop 'init)                               ;; bad
(reduce noop 'init '(123))
(reduce noop 'init '(123) '(456))                 ;; bad

(reduce (lambda () #f) 0 '(123))                  ;; bad
(reduce (lambda (x) #f) 0 '(123))                 ;; bad
(reduce (lambda (x prev) #f) 0 '(123))
(reduce (lambda (x y prev) #f) 0 '(123))          ;; bad
(reduce (lambda (x y z prev) #f) 0 '(123))        ;; bad


;;-----------------------------------------------------------------------------
;; reduce-right

(pk reduce-right)
(reduce-right)                                    ;; bad
(reduce-right noop)                               ;; bad
(reduce-right noop 'init)                         ;; bad
(reduce-right noop 'init '(123))
(reduce-right noop 'init '(123) '(456))           ;; bad

(reduce-right (lambda () #f) 0 '(123))            ;; bad
(reduce-right (lambda (x) #f) 0 '(123))           ;; bad
(reduce-right (lambda (x prev) #f) 0 '(123))
(reduce-right (lambda (x y prev) #f) 0 '(123))    ;; bad
(reduce-right (lambda (x y z prev) #f) 0 '(123))  ;; bad


;;-----------------------------------------------------------------------------
;; remove

(remove (lambda () #f) '(123))          ;; bad
(remove (lambda (x) #f) '(123))
(remove (lambda (x y) #f) '(123))       ;; bad


;;-----------------------------------------------------------------------------
;; remove!

(remove! (lambda () #f) '(123))         ;; bad
(remove! (lambda (x) #f) '(123))
(remove! (lambda (x y) #f) '(123))      ;; bad


;;-----------------------------------------------------------------------------
;; span

(span (lambda () #f) '(123))       ;; bad
(span (lambda (x) #f) '(123))
(span (lambda (x y) #f) '(123))    ;; bad


;;-----------------------------------------------------------------------------
;; span!

(span! (lambda () #f) '(123))      ;; bad
(span! (lambda (x) #f) '(123))
(span! (lambda (x y) #f) '(123))   ;; bad


;;-----------------------------------------------------------------------------
;; take-while

(take-while (lambda () #f) '(123))       ;; bad
(take-while (lambda (x) #f) '(123))
(take-while (lambda (x y) #f) '(123))    ;; bad


;;-----------------------------------------------------------------------------
;; take-while!

(take-while! (lambda () #f) '(123))      ;; bad
(take-while! (lambda (x) #f) '(123))
(take-while! (lambda (x y) #f) '(123))   ;; bad


;;-----------------------------------------------------------------------------
;; unfold

(pk unfold)
(unfold)                                       ;; bad
(unfold (lambda (x) #t))                       ;; bad
(unfold (lambda (x) #t) noop)                  ;; bad
(unfold (lambda (x) #t) noop noop)             ;; bad
(unfold (lambda (x) #t) noop noop #f)
(unfold (lambda (x) #t) noop noop #f noop)
(unfold (lambda (x) #t) noop noop #f noop 999) ;; bad

(unfold (lambda () #t) noop noop #f noop)      ;; bad
(unfold (lambda (x) #t) noop noop #f noop)
(unfold (lambda (x y) #t) noop noop #f noop)   ;; bad

(unfold noop (lambda () #t) noop #f noop)      ;; bad
(unfold noop (lambda (x) #t) noop #f noop)
(unfold noop (lambda (x y) #t) noop #f noop)   ;; bad

(unfold noop noop (lambda () #t) #f noop)      ;; bad
(unfold noop noop (lambda (x) #t) #f noop)
(unfold noop noop (lambda (x y) #t) #f noop)   ;; bad

(unfold noop noop #f noop (lambda () #t))      ;; bad
(unfold noop noop #f noop (lambda (x) #t))
(unfold noop noop #f noop (lambda (x y) #t))   ;; bad


;;-----------------------------------------------------------------------------
;; unfold-right

(pk unfold-right)
(unfold-right)                                       ;; bad
(unfold-right (lambda (x) #t))                       ;; bad
(unfold-right (lambda (x) #t) noop)                  ;; bad
(unfold-right (lambda (x) #t) noop noop)             ;; bad
(unfold-right (lambda (x) #t) noop noop #f)
(unfold-right (lambda (x) #t) noop noop #f noop)
(unfold-right (lambda (x) #t) noop noop #f noop 999) ;; bad

(unfold-right (lambda () #t) noop noop #f noop)      ;; bad
(unfold-right (lambda (x) #t) noop noop #f noop)
(unfold-right (lambda (x y) #t) noop noop #f noop)   ;; bad

(unfold-right noop (lambda () #t) noop #f noop)      ;; bad
(unfold-right noop (lambda (x) #t) noop #f noop)
(unfold-right noop (lambda (x y) #t) noop #f noop)   ;; bad

(unfold-right noop noop (lambda () #t) #f noop)      ;; bad
(unfold-right noop noop (lambda (x) #t) #f noop)
(unfold-right noop noop (lambda (x y) #t) #f noop)   ;; bad

(unfold-right noop noop #f noop (lambda () #t))      ;; bad
(unfold-right noop noop #f noop (lambda (x) #t))
(unfold-right noop noop #f noop (lambda (x y) #t))   ;; bad
