;; Test module (srfi srfi-14).

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(use-modules (srfi srfi-14))


;;-----------------------------------------------------------------------------
;; char-set-any

(pk char-set-any)
(char-set-any)                                 	    ;; bad
(char-set-any noop)                            	    ;; bad
(char-set-any noop char-set:lower-case)
(char-set-any noop char-set:lower-case 999)    	    ;; bad

(char-set-any (lambda () #f) char-set:lower-case)      ;; bad
(char-set-any (lambda (c) #f) char-set:lower-case)
(char-set-any (lambda (c x) #f) char-set:lower-case)   ;; bad


;;-----------------------------------------------------------------------------
;; char-set-count

(pk char-set-count)
(char-set-count)                                 	    ;; bad
(char-set-count noop)                            	    ;; bad
(char-set-count noop char-set:lower-case)
(char-set-count noop char-set:lower-case 999)    	    ;; bad

(char-set-count (lambda () #f) char-set:lower-case)      ;; bad
(char-set-count (lambda (c) #f) char-set:lower-case)
(char-set-count (lambda (c x) #f) char-set:lower-case)   ;; bad


;;-----------------------------------------------------------------------------
;; char-set-every

(pk char-set-every)
(char-set-every)                                 	    ;; bad
(char-set-every noop)                            	    ;; bad
(char-set-every noop char-set:lower-case)
(char-set-every noop char-set:lower-case 999)    	    ;; bad

(char-set-every (lambda () #f) char-set:lower-case)      ;; bad
(char-set-every (lambda (c) #f) char-set:lower-case)
(char-set-every (lambda (c x) #f) char-set:lower-case)   ;; bad


;;-----------------------------------------------------------------------------
;; char-set-filter

(pk char-set-filter)
(char-set-filter)                                 	            ;; bad
(char-set-filter noop)                            	            ;; bad
(char-set-filter noop char-set:lower-case)
(char-set-filter noop char-set:lower-case char-set:upper-case)
(char-set-filter noop char-set:lower-case char-set:upper-case 999)  ;; bad

(char-set-filter (lambda () #f) char-set:lower-case)      ;; bad
(char-set-filter (lambda (c) #f) char-set:lower-case)
(char-set-filter (lambda (c x) #f) char-set:lower-case)   ;; bad


;;-----------------------------------------------------------------------------
;; char-set-filter!

(define char-set-filter!-test1 (char-set-copy char-set:lower-case))

(pk char-set-filter!)
(char-set-filter!)                                                     ;; bad
(char-set-filter! noop)                                                ;; bad
(char-set-filter! noop char-set:lower-case)                            ;; bad
(char-set-filter! noop char-set:lower-case char-set-filter!-test1)
(char-set-filter! noop char-set:lower-case char-set-filter!-test1 999) ;; bad

(char-set-filter! (lambda () #f)                                       ;; bad
		  char-set:lower-case char-set-filter!-test1)
(char-set-filter! (lambda (c) #f)
		  char-set:lower-case char-set-filter!-test1)
(char-set-filter! (lambda (c x) #f)                                    ;; bad
		  char-set:lower-case char-set-filter!-test1)


;;-----------------------------------------------------------------------------
;; char-set-fold

(pk char-set-fold)
(char-set-fold)                                 	    	  ;; bad
(char-set-fold noop)                            	    	  ;; bad
(char-set-fold noop 'init)                            	    	  ;; bad
(char-set-fold noop 'init char-set:lower-case)
(char-set-fold noop 'init char-set:lower-case 999)    	    	  ;; bad

(char-set-fold (lambda () #f) 'init char-set:lower-case)          ;; bad
(char-set-fold (lambda (c) #f) 'init char-set:lower-case)         ;; bad
(char-set-fold (lambda (c prev) #f) 'init char-set:lower-case)
(char-set-fold (lambda (c prev x) #f) 'init char-set:lower-case)  ;; bad


;;-----------------------------------------------------------------------------
;; char-set-for-each

(pk char-set-for-each)
(char-set-for-each)                                 	    ;; bad
(char-set-for-each noop)                            	    ;; bad
(char-set-for-each noop char-set:lower-case)
(char-set-for-each noop char-set:lower-case 999)    	    ;; bad

(char-set-for-each (lambda () #f) char-set:lower-case)      ;; bad
(char-set-for-each (lambda (c) #f) char-set:lower-case)
(char-set-for-each (lambda (c x) #f) char-set:lower-case)   ;; bad


;;-----------------------------------------------------------------------------
;; char-set-map

(pk char-set-map)
(char-set-map)                                 	    ;; bad
(char-set-map noop)                            	    ;; bad
(char-set-map noop char-set:lower-case)
(char-set-map noop char-set:lower-case 999)    	    ;; bad

(char-set-map (lambda () #f) char-set:lower-case)      ;; bad
(char-set-map (lambda (c) #f) char-set:lower-case)
(char-set-map (lambda (c x) #f) char-set:lower-case)   ;; bad


;;-----------------------------------------------------------------------------
;; char-set-unfold

(pk char-set-unfold)
(char-set-unfold)                                 	               ;; bad
(char-set-unfold (lambda (s) #t))                            	       ;; bad
(char-set-unfold (lambda (s) #t) (lambda (s) #\x))                     ;; bad
(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen))   ;; bad
(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen) 'seed)
(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen) 'seed
		 char-set:lower-case)
(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)    ;; bad
		 'seed char-set:lower-case 999)

(char-set-unfold (lambda () #t) (lambda (s) #\x) (lambda (s) 'gen)     ;; bad
		 'seed)
(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)
		 'seed)
(char-set-unfold (lambda (s x) #t) (lambda (s) #\x) (lambda (s) 'gen)  ;; bad
		 'seed)

(char-set-unfold (lambda (s) #t) (lambda () #\x) (lambda (s) 'gen)     ;; bad
		 'seed)
(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)
		 'seed)
(char-set-unfold (lambda (s) #t) (lambda (s x) #\x) (lambda (s) 'gen)  ;; bad
		 'seed)

(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda () 'gen)     ;; bad
		 'seed)
(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)
		 'seed)
(char-set-unfold (lambda (s) #t) (lambda (s) #\x) (lambda (s x) 'gen)  ;; bad
		 'seed)


;;-----------------------------------------------------------------------------
;; char-set-unfold!

(define char-set-unfold!-test1 (char-set-copy char-set:lower-case))

(pk char-set-unfold!)
(char-set-unfold!)                                 	                ;; bad
(char-set-unfold! (lambda (s) #t))                            	        ;; bad
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x))                     ;; bad
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen))   ;; bad
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)    ;; bad
		  'seed)
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)
		  'seed char-set-unfold!-test1)
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)    ;; bad
		  'seed char-set-unfold!-test1 999)

(char-set-unfold! (lambda () #t) (lambda (s) #\x) (lambda (s) 'gen)     ;; bad
		  'seed char-set-unfold!-test1)
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)
		  'seed char-set-unfold!-test1)
(char-set-unfold! (lambda (s x) #t) (lambda (s) #\x) (lambda (s) 'gen)  ;; bad
		  'seed char-set-unfold!-test1)

(char-set-unfold! (lambda (s) #t) (lambda () #\x) (lambda (s) 'gen)     ;; bad
		  'seed char-set-unfold!-test1)
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)
		  'seed char-set-unfold!-test1)
(char-set-unfold! (lambda (s) #t) (lambda (s x) #\x) (lambda (s) 'gen)  ;; bad
		  'seed char-set-unfold!-test1)

(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda () 'gen)     ;; bad
		  'seed char-set-unfold!-test1)
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda (s) 'gen)
		  'seed char-set-unfold!-test1)
(char-set-unfold! (lambda (s) #t) (lambda (s) #\x) (lambda (s x) 'gen)  ;; bad
		  'seed char-set-unfold!-test1)


