;; Test module (srfi srfi-19).

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(use-modules ((srfi srfi-19)
	      ;; avoid clash with core current-time
	      #:renamer (symbol-prefix-proc 'srfi19:)))


;;-----------------------------------------------------------------------------
;; current-time

(srfi19:current-time)
(srfi19:current-time srfi19:time-utc)
(srfi19:current-time srfi19:time-utc 999)    ;; bad


;;-----------------------------------------------------------------------------
;; date->string

(srfi19:date->string)                                      ;; bad
(srfi19:date->string (srfi19:current-date))
(srfi19:date->string (srfi19:current-date) "~a")
(srfi19:date->string (srfi19:current-date) "~a" 99)        ;; bad


;;-----------------------------------------------------------------------------
;; current-date

(srfi19:current-date)
(srfi19:current-date 0)
(srfi19:current-date 0 99)            ;; bad


;;-----------------------------------------------------------------------------
;; julian-day->date

(srfi19:julian-day->date)             ;; bad
(srfi19:julian-day->date 0)
(srfi19:julian-day->date 0 0)
(srfi19:julian-day->date 0 0 99)      ;; bad


;;-----------------------------------------------------------------------------
;; modified-julian-day->date

(srfi19:modified-julian-day->date)             ;; bad
(srfi19:modified-julian-day->date 0)
(srfi19:modified-julian-day->date 0 0)
(srfi19:modified-julian-day->date 0 0 99)      ;; bad


;;-----------------------------------------------------------------------------
;; time-monotonic

(pk srfi19:time-monotonic)
time-monotonic        ;; bad


;;-----------------------------------------------------------------------------
;; time-monotonic->date

(srfi19:time-monotonic->date)                                           ;; bad
(srfi19:time-monotonic->date (srfi19:current-time srfi19:time-monotonic))
(srfi19:time-monotonic->date (srfi19:current-time srfi19:time-monotonic) 0)
(srfi19:time-monotonic->date (srfi19:current-time srfi19:time-monotonic) 0 99) ;; bad


;;-----------------------------------------------------------------------------
;; time-resolution

(srfi19:time-resolution)
(srfi19:time-resolution srfi19:time-utc)
(srfi19:time-resolution srfi19:time-utc 99)                ;; bad


;;-----------------------------------------------------------------------------
;; time-tai

(pk srfi19:time-tai)
time-tai              ;; bad


;;-----------------------------------------------------------------------------
;; time-tai->date

(srfi19:time-tai->date)                                             ;; bad
(srfi19:time-tai->date (srfi19:current-time srfi19:time-tai))
(srfi19:time-tai->date (srfi19:current-time srfi19:time-tai) 0)
(srfi19:time-tai->date (srfi19:current-time srfi19:time-tai) 0 99)  ;; bad


;;-----------------------------------------------------------------------------
;; time-utc

(pk srfi19:time-utc)
time-utc              ;; bad


;;-----------------------------------------------------------------------------
;; time-utc->date

(srfi19:time-utc->date)                                             ;; bad
(srfi19:time-utc->date (srfi19:current-time srfi19:time-utc))
(srfi19:time-utc->date (srfi19:current-time srfi19:time-utc) 0)
(srfi19:time-utc->date (srfi19:current-time srfi19:time-utc) 0 99)  ;; bad
