;; Test module (srfi srfi-34).

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


guard                  ;; bad
with-exception-handler ;; bad

(use-modules (srfi srfi-34))


;;-----------------------------------------------------------------------------
;; guard

(pk guard)
(guard)                     ;; bad
(guard (x))                 ;; bad
(guard (x) #f)              ;; bad
(guard (x (else 123)))      ;; bad
(guard (x (else 123)) #f)

(guard 123 #f)              ;; bad
(guard () #f)               ;; bad

(guard (x (else 123))
  (nodef))                  ;; bad

(guard (x (else 123))
  #f)
(guard (x
	(else 123)          ;; bad
	(else 123))
  #f)

(guard (x (#t (display x)))
  #f)
(guard (x (#t 123 (display x))) ;; bad (literal called for effect)
  #f)
(guard (x (#t (pk 123) (display x)))
  #f)

(guard (x ())               ;; bad, empty clause
  #f)


;;-----------------------------------------------------------------------------
;; raise

(pk raise)
(raise)                     ;; bad
(raise 123)
(raise "foo")
(raise "foo" "bar")         ;; bad


;;-----------------------------------------------------------------------------
;; with-exception-handler

(pk with-exception-handler)
(with-exception-handler)                                    ;; bad
(with-exception-handler (lambda (obj) #f))                  ;; bad
(with-exception-handler (lambda (obj) #f) (lambda () #f))

(with-exception-handler (lambda (obj) #f) (lambda () #f))
(with-exception-handler (lambda (obj) #f) (lambda (x) #f))  ;; bad

(with-exception-handler (lambda () #f) (lambda () #f))      ;; bad
(with-exception-handler (lambda (obj) #f) (lambda () #f))
(with-exception-handler (lambda (obj x) #f) (lambda () #f)) ;; bad


