;; Test module (srfi srfi-39).

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


make-parameter    ;; bad
parameterize      ;; bad
with-parameters*  ;; bad

(use-modules (srfi srfi-39))


;;-----------------------------------------------------------------------------
;; make-parameter

(pk make-parameter)
(pk (make-parameter))                             ;; bad
(make-parameter 123)                              ;; bad (called for effect)
(pk (make-parameter 123))
(pk (make-parameter 123 noop))
(pk (make-parameter 123 noop 456))                ;; bad

(pk (make-parameter 123 (lambda () #f)))          ;; bad
(pk (make-parameter 123 (lambda (value) value)))
(pk (make-parameter 123 (lambda (x y) #f)))       ;; bad
(pk (make-parameter 123 expt))                    ;; bad


;;-----------------------------------------------------------------------------
;; parameterize

(pk parameterize)
(pk (parameterize))                        ;; bad
(pk (parameterize ()))                     ;; bad
(pk (parameterize () #f))

(pk (parameterize (x) #f))                 ;; bad
(pk (parameterize ((x)) #f))               ;; bad
(pk (parameterize ((99 99) . x) #f))       ;; bad

(define parameterize-test1-param (make-parameter 123))
(parameterize ((parameterize-test1-param 456)) #f)

(parameterize ;; bad (literals 1, 2 called for effect)
    ((parameterize-test1-param 99)) 
  1 2 3)
(parameterize
    ((parameterize-test1-param 99)) 
  (pk 1) (pk 2) 3)


;;-----------------------------------------------------------------------------
;; with-parameters*

(pk with-parameters*)
(pk (with-parameters*))                    	   ;; bad
(pk (with-parameters* '()))                	   ;; bad
(pk (with-parameters* '() '()))            	   ;; bad
(pk (with-parameters* '() '() noop))
(pk (with-parameters* '() '() log))        	   ;; bad
(pk (with-parameters* '() '() (lambda () #f)))
(pk (with-parameters* '() '() (lambda (x) #f))) ;; bad
