;; Test module (srfi srfi-60), new in guile 1.8.

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


copy-bit  ;; bad

(use-modules (srfi srfi-60))


;;-----------------------------------------------------------------------------
;; any-bits-set?  (alias for logtest)

(pk any-bits-set?)
(pk (any-bits-set?))          ;; bad
(pk (any-bits-set? 1))        ;; bad
(pk (any-bits-set? 1 2))
(pk (any-bits-set? 1 #\x))    ;; bad
(pk (any-bits-set? #\x 1))    ;; bad


;;-----------------------------------------------------------------------------
;; arithmetic-shift   (alias for ash)

(pk arithmetic-shift)
(pk (arithmetic-shift))             ;; bad
(pk (arithmetic-shift 1))           ;; bad
(pk (arithmetic-shift 1 2))
(pk (arithmetic-shift -1 2))
(pk (arithmetic-shift 1 -2))
(pk (arithmetic-shift -1 -2))
(pk (arithmetic-shift #\x 2))       ;; bad
(pk (arithmetic-shift 1 #\x))       ;; bad


;;-----------------------------------------------------------------------------
;; bitwise-and

(pk bitwise-and)
(pk (bitwise-and))
(pk (bitwise-and 1))
(pk (bitwise-and 1 2))
(pk (bitwise-and 1 #\x))    ;; bad
(pk (bitwise-and #\x 1))    ;; bad


;;-----------------------------------------------------------------------------
;; bitwise-if

(pk bitwise-if)
(pk (bitwise-if))                   ;; bad
(pk (bitwise-if 1))                 ;; bad
(pk (bitwise-if 1 2))               ;; bad
(bitwise-if 1 2 3)      	    ;; bad (called for effect)
(pk (bitwise-if 1 2 3))
(pk (bitwise-if #\x 2 3))   	    ;; bad
(pk (bitwise-if 1 #\x 3))   	    ;; bad
(pk (bitwise-if 1 2 #\x))   	    ;; bad
(pk (bitwise-if 1 2 3 4))   	    ;; bad


;;-----------------------------------------------------------------------------
;; bitwise-ior

(pk bitwise-ior)
(pk (bitwise-ior))
(pk (bitwise-ior 1))
(pk (bitwise-ior 1 2))
(pk (bitwise-ior 1 #\x))    ;; bad
(pk (bitwise-ior #\x 1))    ;; bad


;;-----------------------------------------------------------------------------
;; bitwise-merge   (alias for bitwise-if)

(pk bitwise-merge)
(pk (bitwise-merge))             ;; bad
(pk (bitwise-merge 1))           ;; bad
(pk (bitwise-merge 1 2))         ;; bad
(bitwise-merge 1 2 3)            ;; bad (called for effect)
(pk (bitwise-merge 1 2 3))
(pk (bitwise-merge #\x 2 3))     ;; bad
(pk (bitwise-merge 1 #\x 3))     ;; bad
(pk (bitwise-merge 1 2 #\x))     ;; bad
(pk (bitwise-merge 1 2 3 4))     ;; bad


;;-----------------------------------------------------------------------------
;; bitwise-not

(pk bitwise-not)
(pk (bitwise-not))          ;; bad
(pk (bitwise-not 1))
(pk (bitwise-not 1 2))      ;; bad
(pk (bitwise-not #\x))      ;; bad


;;-----------------------------------------------------------------------------
;; bitwise-xor

(pk bitwise-xor)
(pk (bitwise-xor))
(pk (bitwise-xor 1))
(pk (bitwise-xor 1 2))
(pk (bitwise-xor 1 #\x))    ;; bad
(pk (bitwise-xor #\x 1))    ;; bad


;;-----------------------------------------------------------------------------
;; bit-count   (alias for logcount)

(pk bit-count)
(pk (bit-count))            ;; bad
(pk (bit-count 1))
(pk (bit-count -1))
(pk (bit-count 1 2))        ;; bad
(pk (bit-count #\x))        ;; bad


;;-----------------------------------------------------------------------------
;; bit-field   (alias for bit-extract)

(pk bit-field)
(pk (bit-field))            	 ;; bad
(pk (bit-field 1))          	 ;; bad
(pk (bit-field 1 0))        	 ;; bad
(pk (bit-field 1 0 3))
(pk (bit-field -1 0 3))
(pk (bit-field #\x 0 3))    	 ;; bad
(pk (bit-field -1 -1 3))    	 ;; bad
(pk (bit-field -1 1 -3))    	 ;; bad
(pk (bit-field -1 -1 -3))   	 ;; bad
(pk (bit-field -1 3 3))
(pk (bit-field -1 3 2))  ;; notyet bad (start > end in literals)


;;-----------------------------------------------------------------------------
;; bit-set?   (alias for logbit?)

(pk bit-set?)
(pk (bit-set?))             ;; bad
(pk (bit-set? 1))           ;; bad
(pk (bit-set? 1 2))
(pk (bit-set? -1 2))        ;; bad
(pk (bit-set? #\x 2))       ;; bad
(pk (bit-set? 1 #\x))       ;; bad


;;-----------------------------------------------------------------------------
;; copy-bit

(pk copy-bit)
(pk (copy-bit))               ;; bad
(pk (copy-bit 1))             ;; bad
(pk (copy-bit 1 123))         ;; bad
(copy-bit 1 123 #t)           ;; bad (called for effect)
(pk (copy-bit 1 123 #t))
(pk (copy-bit #\x 123 #t))    ;; bad
(pk (copy-bit -1 123 #t))     ;; bad
(pk (copy-bit 1 #\x #t))      ;; bad
(pk (copy-bit 1 123 #\x))     ;; bad
(pk (copy-bit 1 123 #t 456))  ;; bad


;;-----------------------------------------------------------------------------
;; copy-bit-field

(pk copy-bit-field)
(pk (copy-bit-field))               	     ;; bad
(pk (copy-bit-field 123))           	     ;; bad
(pk (copy-bit-field 123 456))       	     ;; bad
(pk (copy-bit-field 123 456 0))     	     ;; bad
(copy-bit-field 123 456 0 3)        	     ;; bad (called for effect)
(pk (copy-bit-field 123 456 0 3))
(pk (copy-bit-field -123 456 0 3))
(pk (copy-bit-field 123 -456 0 3))
(pk (copy-bit-field -123 -456 0 3))
(pk (copy-bit-field 123 456 0 3 5))       ;; bad

(pk (copy-bit-field #\x 456 0 3))   	     ;; bad
(pk (copy-bit-field 123 #\x 0 3))   	     ;; bad
(pk (copy-bit-field 123 456 #\x 3)) 	     ;; bad
(pk (copy-bit-field 123 456 -1 3))  	     ;; bad
(pk (copy-bit-field #\x 456 0 -3))  	     ;; bad
(pk (copy-bit-field 123 456 -5 -4)) 	     ;; bad
(pk (copy-bit-field 123 456 6 2))   	     ;; notyet bad (start > end)


;;-----------------------------------------------------------------------------
;; integer->list

(pk integer->list)
(pk (integer->list))                ;; bad
(integer->list 123)                 ;; bad (called for effect)
(pk (integer->list 123))
(pk (integer->list -123))
(pk (integer->list 123 5))
(pk (integer->list 123 5 6))        ;; bad

(pk (integer->list #\x))            ;; bad
(pk (integer->list #\x 5))          ;; bad
(pk (integer->list 123 #\x))        ;; bad
(pk (integer->list #\x -5))         ;; bad


;;-----------------------------------------------------------------------------
;; list->integer

(pk list->integer)
(pk (list->integer))                ;; bad
(list->integer '())                 ;; bad (called for effect)
(pk (list->integer '()))
(pk (list->integer '(#f)))
(pk (list->integer '(#t #f)))
(pk (list->integer '(#t #f) 99))    ;; bad


;;-----------------------------------------------------------------------------
;; booleans->integer

(pk booleans->integer)
(pk (booleans->integer))
(booleans->integer #t)                   ;; bad (called for effect)
(pk (booleans->integer #f #t))
(pk (booleans->integer 0 1))             ;; bad
(pk (booleans->integer 1 #t #f))         ;; bad
(pk (booleans->integer #t 1 #f))         ;; bad
(pk (booleans->integer #t #f 1))         ;; bad
(pk (apply booleans->integer '(#t #f)))  ;; bad


;;-----------------------------------------------------------------------------
;; first-set-bit

(pk first-set-bit)
(pk (first-set-bit))                     ;; bad
(first-set-bit 123)                      ;; bad (called for effect)
(pk (first-set-bit 123))
(pk (first-set-bit -123))
(pk (first-set-bit -123 456))            ;; bad


;;-----------------------------------------------------------------------------
;; log2-binary-factors

(pk log2-binary-factors)
(pk (log2-binary-factors))               ;; bad
(log2-binary-factors 123)                ;; bad (called for effect)
(pk (log2-binary-factors 123))
(pk (log2-binary-factors -123))
(pk (log2-binary-factors -123 456))      ;; bad


;;-----------------------------------------------------------------------------
;; reverse-bit-field

(pk reverse-bit-field)
(pk (reverse-bit-field))                 ;; bad
(pk (reverse-bit-field 123))             ;; bad
(pk (reverse-bit-field 123 0))           ;; bad
(reverse-bit-field 123 0 3)              ;; bad (called for effect)
(pk (pk (reverse-bit-field 123 0 3)))
(pk (reverse-bit-field 123 0 3 5))       ;; bad

(pk (reverse-bit-field #\x 0 3))         ;; bad
(pk (reverse-bit-field 123 #\x 3))       ;; bad
(pk (reverse-bit-field 123 0 #\x))       ;; bad
(pk (reverse-bit-field 123 -1 3))        ;; bad
(pk (reverse-bit-field 123 0 -3))        ;; bad
(pk (reverse-bit-field 123 -6 -4))       ;; bad
(pk (reverse-bit-field 123 6 2))         ;; notyet bad


;;-----------------------------------------------------------------------------
;; rotate-bit-field

(pk rotate-bit-field)
(pk (rotate-bit-field))                  ;; bad
(pk (rotate-bit-field 123))              ;; bad
(pk (rotate-bit-field 123 3))            ;; bad
(pk (rotate-bit-field 123 3 0))          ;; bad
(rotate-bit-field 123 3 0 5)             ;; bad (called for effect)
(pk (rotate-bit-field 123 3 0 5))
(pk (rotate-bit-field 123 -3 0 5))
(pk (rotate-bit-field -123 -3 0 5))
(pk (rotate-bit-field 123 3 0 5 6))      ;; bad

(pk (rotate-bit-field #\x 3 0 5))        ;; bad
(pk (rotate-bit-field 123 #\x 0 5))      ;; bad
(pk (rotate-bit-field 123 3 #\x 5))      ;; bad
(pk (rotate-bit-field 123 3 0 #\x))      ;; bad
(pk (rotate-bit-field 123 3 -1 5))       ;; bad
(pk (rotate-bit-field 123 3 0 -5))       ;; bad
(pk (rotate-bit-field 123 3 -6 -4))      ;; bad
(pk (rotate-bit-field 123 3 6 2))        ;; notyet bad
