;; Test module (ice-9 streams).

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(use-modules (ice-9 streams))


;;-----------------------------------------------------------------------------
;; stream-fold

(define stream-fold-test1 (make-stream (lambda (proc state) 123) #f))
(define stream-fold-test2 (make-stream (lambda (proc state) 123) #f))

(stream-fold)                                                  ;; bad
(stream-fold (lambda (x prev) #f))                             ;; bad
(stream-fold (lambda (x prev) #f) 'init)                       ;; bad
(stream-fold (lambda (x prev) #f) 'init stream-fold-test1)

(stream-fold (lambda () #f) 'init stream-fold-test1)           ;; bad
(stream-fold (lambda (prev) #f) 'init stream-fold-test1)       ;; bad
(stream-fold (lambda (x prev) #f) 'init stream-fold-test1)
(stream-fold (lambda (x y prev) #f) 'init stream-fold-test1)   ;; bad
(stream-fold (lambda (x y z prev) #f) 'init stream-fold-test1) ;; bad

(stream-fold (lambda () #f) 'init                              ;; bad
	     stream-fold-test1 stream-fold-test2)
(stream-fold (lambda (prev) #f) 'init                          ;; bad
	     stream-fold-test1 stream-fold-test2)
(stream-fold (lambda (x prev) #f) 'init                        ;; bad
	     stream-fold-test1 stream-fold-test2)
(stream-fold (lambda (x y prev) #f) 'init
	     stream-fold-test1 stream-fold-test2)
(stream-fold (lambda (x y z prev) #f) 'init                    ;; bad
	     stream-fold-test1 stream-fold-test2)


;;-----------------------------------------------------------------------------
;; stream-for-each

(define stream-for-each-test1 (make-stream (lambda (proc state) 123) #f))
(define stream-for-each-test2 (make-stream (lambda (proc state) 123) #f))

(pk stream-for-each)
(stream-for-each)                                                ;; bad
(stream-for-each (lambda (x) #f))                                ;; bad
(stream-for-each (lambda (x) #f) stream-for-each-test1)

(stream-for-each (lambda () #f) stream-for-each-test1)           ;; bad
(stream-for-each (lambda (x) #f) stream-for-each-test1)
(stream-for-each (lambda (x y) #f) stream-for-each-test1)        ;; bad
(stream-for-each (lambda (x y z) #f) stream-for-each-test1)      ;; bad

(stream-for-each (lambda () #f)                                  ;; bad
		 stream-for-each-test1 stream-for-each-test2)
(stream-for-each (lambda (x) #f)                                 ;; bad
		 stream-for-each-test1 stream-for-each-test2)
(stream-for-each (lambda (x y) #f)
		 stream-for-each-test1 stream-for-each-test2)
(stream-for-each (lambda (x y z) #f)                             ;; bad
		 stream-for-each-test1 stream-for-each-test2)


;;-----------------------------------------------------------------------------
;; stream-map

(define stream-map-test1 (make-stream (lambda (proc state) 123) #f))
(define stream-map-test2 (make-stream (lambda (proc state) 123) #f))

(pk stream-map)
(stream-map)                                           ;; bad
(stream-map (lambda (x) #f))                           ;; bad
(stream-map (lambda (x) #f) stream-map-test1)

(stream-map (lambda () #f) stream-map-test1)           ;; bad
(stream-map (lambda (x) #f) stream-map-test1)
(stream-map (lambda (x y) #f) stream-map-test1)        ;; bad
(stream-map (lambda (x y z) #f) stream-map-test1)      ;; bad

(stream-map (lambda () #f)                             ;; bad
		 stream-map-test1 stream-map-test2)
(stream-map (lambda (x) #f)                            ;; bad
		 stream-map-test1 stream-map-test2)
(stream-map (lambda (x y) #f)
		 stream-map-test1 stream-map-test2)
(stream-map (lambda (x y z) #f)                        ;; bad
		 stream-map-test1 stream-map-test2)
