;; Test module (ice-9 syncase).

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


define-syntax                                             ;; bad
(use-modules (ice-9 syncase))


;;-----------------------------------------------------------------------------
;; define-syntax

(define-syntax)       		                          ;; bad
(define-syntax define-syntax-test1)     		  ;; bad
(define-syntax define-syntax-test2 ())  		  ;; bad
(define-syntax define-syntax-test3 123) 		  ;; bad
(define-syntax define-syntax-test4 (syntax-rules))        ;; bad
(define-syntax define-syntax-test5 (syntax-rules . 123))  ;; bad
(define-syntax define-syntax-test6 (syntax-rules ()))     ;; bad
(define-syntax define-syntax-test7 (syntax-rules (1 2 3)  ;; bad
				     ((define-syntax-test7) (123))))
(define-syntax define-syntax-test8 (syntax-rules a        ;; bad
				     ((define-syntax-test8) (123))))
(define-syntax define-syntax-test9 (syntax-rules (a . b)  ;; bad
				     ((define-syntax-test9) (123))))
(define-syntax define-syntax-test10 (syntax-rules ()
				      (123                ;; bad
				       (123))))
(define-syntax define-syntax-test11 (syntax-rules ()
				      ((x)                ;; bad
				       (123))))

(define-syntax define-syntax-test12 (syntax-rules (...)   ;; bad
				      ((define-syntax-test12) (123))))

(define-syntax define-syntax-test13 (syntax-rules (z ...) ;; bad
				      ((define-syntax-test13) (123))))

(define-syntax define-syntax-test14 (syntax-rules (... z) ;; bad
				      ((define-syntax-test14) (123))))

(define-syntax define-syntax-test15 (syntax-rules ()
		   ((define-syntax-test15)
		    (123))))
(pk define-syntax-test15)

(define-syntax define-syntax-test16 (syntax-rules ()
				      ((define-syntax-test16)
				       (123))
				      ((define-syntax-test16 y)
				       (123))))
(pk define-syntax-test16)

(define-syntax define-syntax-test17
  (syntax-rules ()
    ((define-syntax-test17 x)
     (pk (car x)))))
(define-syntax-test17 123)      ;; bad
(define-syntax-test17 123 456)  ;; notyet bad

(define-syntax define-syntax-test18
  (syntax-rules ()
    ((define-syntax-test18 x . y)
     (pk x y))))
(define-syntax-test18 123)
(define-syntax-test18 123 noop)


;;-----------------------------------------------------------------------------
;; let-syntax

(let-syntax ((foo (syntax-rules () ((foo x) (car x)))))
  #f)

(let-syntax ((foo (syntax-rules () ((foo x) (car x))))
	     (foo (syntax-rules () ((foo x) (car x))))) ;; bad
  #f)

(let-syntax () #f)
(let-syntax ())           ;; bad

(let-syntax ()
  (define x 1)
  x)

(let-syntax ()            ;; bad
  (define x 1))           ;; bad (unused)

(let-syntax ()
  (pk (noop))
  (define x 1))           ;; bad


;;-----------------------------------------------------------------------------
;; letrec-syntax

(letrec-syntax () #f)
(letrec-syntax ())           ;; bad

(letrec-syntax ()            ;; bad
  (define x 1))              ;; bad (unused)

(letrec-syntax ()
  (define x 1)
  x)

(letrec-syntax ()
  (pk (noop))
  (define x 1)               ;; bad
  x)
