;; Test (ice-9 threads) functions specific to guile 1.8.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Guile-Lint.
;;
;; Guile-Lint is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Guile-Lint is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(use-modules (ice-9 threads))


;;-----------------------------------------------------------------------------
;; letpar

(pk letpar)

(letpar "x"               ;; bad
  #f)

(letpar ((x 1))           ;; bad (bare var called for effect)
  x
  x)

(letpar ((x 1))
  (pk x)
  x)


;;-----------------------------------------------------------------------------
;; n-for-each-par-map

(n-for-each-par-map 2 (lambda () #f) (lambda (x) #f) '(123))      	 ;; bad
(n-for-each-par-map 2 (lambda (x) #f) (lambda (x) #f) '(123))
(n-for-each-par-map 2 (lambda (x y) #f) (lambda (x) #f) '(123))   	 ;; bad

(n-for-each-par-map 2 (lambda (x) #f) (lambda () #f) '(123))      	 ;; bad
(n-for-each-par-map 2 (lambda (x) #f) (lambda (x) #f) '(123))
(n-for-each-par-map 2 (lambda (x) #f) (lambda (x y) #f) '(123))   	 ;; bad

(n-for-each-par-map 2 (lambda () #f) (lambda (x y) #f) '(123) '(456))    ;; bad
(n-for-each-par-map 2 (lambda (x) #f) (lambda (x y) #f) '(123) '(456))
(n-for-each-par-map 2 (lambda (x y) #f) (lambda (x y) #f) '(123) '(456)) ;; bad

(n-for-each-par-map 2 (lambda (x) #f) (lambda () #f) '(123) '(456))      ;; bad
(n-for-each-par-map 2 (lambda (x) #f) (lambda (x) #f) '(123) '(456))     ;; bad
(n-for-each-par-map 2 (lambda (x) #f) (lambda (x y) #f) '(123) '(456))
(n-for-each-par-map 2 (lambda (x) #f) (lambda (x y z) #f) '(123) '(456)) ;; bad


;;-----------------------------------------------------------------------------
;; n-par-for-each

(n-par-for-each 2 (lambda () #f) '(123))               ;; bad
(n-par-for-each 2 (lambda (x) #f) '(123))
(n-par-for-each 2 (lambda (x y) #f) '(123))            ;; bad
(n-par-for-each 2 (lambda (x y z) #f) '(123))          ;; bad

(n-par-for-each 2 (lambda () #f) '(123) '(456))        ;; bad
(n-par-for-each 2 (lambda (x) #f) '(123) '(456))       ;; bad
(n-par-for-each 2 (lambda (x y) #f) '(123) '(456))
(n-par-for-each 2 (lambda (x y z) #f) '(123) '(456))   ;; bad


;;-----------------------------------------------------------------------------
;; n-par-map

(n-par-map 2 (lambda () #f) '(123))               ;; bad
(n-par-map 2 (lambda (x) #f) '(123))
(n-par-map 2 (lambda (x y) #f) '(123))            ;; bad
(n-par-map 2 (lambda (x y z) #f) '(123))          ;; bad

(n-par-map 2 (lambda () #f) '(123) '(456))        ;; bad
(n-par-map 2 (lambda (x) #f) '(123) '(456))       ;; bad
(n-par-map 2 (lambda (x y) #f) '(123) '(456))
(n-par-map 2 (lambda (x y z) #f) '(123) '(456))   ;; bad


;;-----------------------------------------------------------------------------
;; par-for-each

(par-for-each (lambda () #f) '(123))               ;; bad
(par-for-each (lambda (x) #f) '(123))
(par-for-each (lambda (x y) #f) '(123))            ;; bad
(par-for-each (lambda (x y z) #f) '(123))          ;; bad

(par-for-each (lambda () #f) '(123) '(456))        ;; bad
(par-for-each (lambda (x) #f) '(123) '(456))       ;; bad
(par-for-each (lambda (x y) #f) '(123) '(456))
(par-for-each (lambda (x y z) #f) '(123) '(456))   ;; bad


;;-----------------------------------------------------------------------------
;; par-map

(par-map (lambda () #f) '(123))               ;; bad
(par-map (lambda (x) #f) '(123))
(par-map (lambda (x y) #f) '(123))            ;; bad
(par-map (lambda (x y z) #f) '(123))          ;; bad

(par-map (lambda () #f) '(123) '(456))        ;; bad
(par-map (lambda (x) #f) '(123) '(456))       ;; bad
(par-map (lambda (x y) #f) '(123) '(456))
(par-map (lambda (x y z) #f) '(123) '(456))   ;; bad


;;-----------------------------------------------------------------------------
;; parallel

(pk parallel)

(parallel
 (noop)
 (noop))

(parallel
 (car 1 2 3))             ;; bad
